# Microeconometrics
# CLASS 9b
# Panel data for count model
# Wiktor Budzinski

rm(list=ls())
library(pglm)
library(pder)

data("GiantsShoulders", package = "pder")
# ACTT (American Type Culture Collection)
# brc - 1 if hosted by the ATCC
# brcyear - which year hosted

GiantsShoulders[GiantsShoulders$pair == 184,]

GiantsShoulders$age <- GiantsShoulders$year - GiantsShoulders$pubyear # How long they have been published
GiantsShoulders$post_brc <- (GiantsShoulders$brc == "yes") & (GiantsShoulders$year - GiantsShoulders$brcyear > 1) # After hosting
GiantsShoulders$window <- (GiantsShoulders$brc == "yes") & (abs(GiantsShoulders$year - GiantsShoulders$brcyear) <= 1) # In the neighberhood of hosting

GiantsShoulders$year[GiantsShoulders$year %in% 1970:1974] <- 1970
GiantsShoulders$year[GiantsShoulders$year %in% 1975:1979] <- 1975

Eq <- citations ~ brc + window + post_brc + age + factor(year)
m1 <- pglm(Eq, data = GiantsShoulders, index = "pair",
             effect = "individual", model = "within", family = poisson)
summary(m1)

# More of the DiD specification

B<- unique(GiantsShoulders$pair)
for(i in 1:length(B)){
  GiantsShoulders$brcyear[GiantsShoulders$pair == B[i] & GiantsShoulders$brcyear == 0] <-
    GiantsShoulders$brcyear[GiantsShoulders$pair == B[i] & GiantsShoulders$brcyear > 0][1]
}
GiantsShoulders[GiantsShoulders$pair == 184,]

GiantsShoulders$brcx <- GiantsShoulders$brc == "yes"
GiantsShoulders$treat <- GiantsShoulders$year >= GiantsShoulders$brcyear
GiantsShoulders$inter <- (GiantsShoulders$treat + 0)*(GiantsShoulders$brcx + 0)

Eq <- citations ~ brc + treat + inter + age + factor(year)
m2 <- pglm(Eq, data = GiantsShoulders, index = "pair",
           effect = "individual", model = "within", family = poisson)
summary(m2)

# Random effect model
m3 <- pglm(Eq, data = GiantsShoulders, index = "pair",
           effect = "individual", model = "random", family = poisson)
summary(m3)
